/// <reference types="node" />
import { EventEmitter } from "events";
import { Packet, Region, Segment } from "./models";
export declare class CaptureInterface extends EventEmitter {
    private readonly _cap;
    private readonly _buf;
    private _opcodeLists;
    private _region;
    constructor(region?: Region);
    setRegion(region: Region): void;
    open(deviceIdentifier: string): void;
    close(): void;
    _loadOpcodes(): Promise<void>;
    private _registerInternalHandlers;
}
interface CaptureInterfaceEvents {
    ready: () => void;
    packet: (packet: Packet) => void;
    segment: (segment: Segment) => void;
    message: (type: string, message: Segment) => void;
}
export declare interface CaptureInterface {
    on<U extends keyof CaptureInterfaceEvents>(event: U, listener: CaptureInterfaceEvents[U]): this;
    emit<U extends keyof CaptureInterfaceEvents>(event: U, ...args: Parameters<CaptureInterfaceEvents[U]>): boolean;
}
export {};
//# sourceMappingURL=pcap-ffxiv.d.ts.map