"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CaptureInterface = void 0;
var cap_1 = require("cap");
var events_1 = require("events");
var frame_processing_1 = require("./frame-processing");
var models_1 = require("./models");
var pako_1 = __importDefault(require("pako"));
var opcode_downloader_1 = require("./opcode-downloader");
var PROTOCOL = cap_1.decoders.PROTOCOL;
var FILTER = "tcp portrange 54992-54994 or tcp portrange 55006-55007 or tcp portrange 55021-55040 or tcp portrange 55296-55551";
var BYTE = 1;
var KILOBYTE = 1024 * BYTE;
var MEGABYTE = 1024 * KILOBYTE;
var FRAME_HEADER_SIZE = 40;
var SEG_HEADER_SIZE = 16;
var IPC_HEADER_SIZE = 16;
var CaptureInterface = /** @class */ (function (_super) {
    __extends(CaptureInterface, _super);
    function CaptureInterface(region) {
        if (region === void 0) { region = "Global"; }
        var _this = _super.call(this) || this;
        _this._cap = new cap_1.Cap();
        _this._buf = Buffer.alloc(65535);
        _this._region = region;
        _this._loadOpcodes().then(function () {
            _this.emit("ready");
        });
        return _this;
    }
    CaptureInterface.prototype.setRegion = function (region) {
        this._region = region;
    };
    CaptureInterface.prototype.open = function (deviceIdentifier) {
        var device = cap_1.Cap.findDevice(deviceIdentifier);
        this._cap.open(device, FILTER, 10 * MEGABYTE, this._buf);
        this._cap.setMinBytes && this._cap.setMinBytes(0);
        this._registerInternalHandlers();
    };
    CaptureInterface.prototype.close = function () {
        this._cap.close();
    };
    CaptureInterface.prototype._loadOpcodes = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this;
                        return [4 /*yield*/, opcode_downloader_1.downloadOpcodes()];
                    case 1:
                        _a._opcodeLists = _b.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    CaptureInterface.prototype._registerInternalHandlers = function () {
        var _this = this;
        this._cap.on("packet", function (nBytes) {
            var _a, _b;
            // The total buffer is way bigger than the relevant data, so we trim that first.
            var payload = _this._buf.slice(0, nBytes);
            var ret = cap_1.decoders.Ethernet(payload);
            if (ret.info.type === PROTOCOL.ETHERNET.IPV4) {
                ret = cap_1.decoders.IPV4(payload, ret.offset);
                // The info object is destroyed once we decode the TCP data from the packet payload.
                var srcAddr = ret.info.srcaddr;
                var dstAddr = ret.info.dstaddr;
                if (ret.info.protocol === PROTOCOL.IP.TCP) {
                    var datalen = ret.info.totallen - ret.hdrlen;
                    ret = cap_1.decoders.TCP(payload, ret.offset);
                    datalen -= ret.hdrlen;
                    if ((ret.info.flags & 8) === 0)
                        return; // Only TCP PSH has actual data.
                    var childFramePayload = payload.slice(payload.length - datalen);
                    var cfHeaderPayload = childFramePayload.slice(0, FRAME_HEADER_SIZE);
                    var frameHeader = frame_processing_1.parseFrameHeader(cfHeaderPayload);
                    if (!frame_processing_1.isMagical(frameHeader))
                        return;
                    var packet = {
                        source: {
                            address: srcAddr,
                            port: ret.info.srcport,
                        },
                        destination: {
                            address: dstAddr,
                            port: ret.info.dstport,
                        },
                        childFrame: {
                            header: frameHeader,
                            segments: [],
                        },
                    };
                    // Decompress the segments, if necessary.
                    var remainder = childFramePayload.slice(FRAME_HEADER_SIZE);
                    if (frameHeader.isCompressed) {
                        try {
                            var decompressed = pako_1.default.inflate(remainder);
                            remainder = Buffer.from(decompressed.buffer);
                        }
                        catch (err) {
                            // This will happen if the packet contents are encrypted.
                            if (err === "incorrect header check") {
                                return;
                            }
                        }
                    }
                    var offset = 0;
                    var _loop_1 = function (i) {
                        var segmentPayload = remainder.slice(offset);
                        var segmentHeader = frame_processing_1.parseSegmentHeader(segmentPayload);
                        var ipcHeader;
                        var ipcData = void 0;
                        if (segmentHeader.segmentType === models_1.SegmentType.Ipc) {
                            var ipcPayload = remainder.slice(offset + SEG_HEADER_SIZE);
                            ipcHeader = frame_processing_1.parseIpcHeader(ipcPayload);
                            ipcData = Buffer.alloc(segmentHeader.size - SEG_HEADER_SIZE - IPC_HEADER_SIZE);
                            ipcPayload.copy(ipcData, 0, IPC_HEADER_SIZE);
                        }
                        var segment = {
                            header: segmentHeader,
                            ipcHeader: ipcHeader,
                            ipcData: ipcData,
                        };
                        packet.childFrame.segments.push();
                        // If the segment is an IPC segment, get the known name of the contained message and fire an event.
                        if (ipcHeader != null) {
                            var regionOpcodes = (_a = _this._opcodeLists) === null || _a === void 0 ? void 0 : _a.find(function (ol) { return ol.region === _this._region; });
                            var opcodeInfo = regionOpcodes === null || regionOpcodes === void 0 ? void 0 : regionOpcodes.lists.ServerZoneIpcType.find(function (oi) { return oi.opcode === (ipcHeader === null || ipcHeader === void 0 ? void 0 : ipcHeader.type); });
                            var typeName = (_b = opcodeInfo === null || opcodeInfo === void 0 ? void 0 : opcodeInfo.name) !== null && _b !== void 0 ? _b : "unknown";
                            typeName = typeName[0].toLowerCase() + typeName.slice(1);
                            _this.emit("message", typeName, segment);
                        }
                        _this.emit("segment", segment);
                        offset += segmentHeader.size;
                    };
                    for (var i = 0; i < frameHeader.segmentCount; i++) {
                        _loop_1(i);
                    }
                    _this.emit("packet", packet);
                }
            }
        });
    };
    return CaptureInterface;
}(events_1.EventEmitter));
exports.CaptureInterface = CaptureInterface;
//# sourceMappingURL=pcap-ffxiv.js.map